"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = require("react");

var _react2 = require("@emotion/react");

var _constants = require("../constants");

var _surfaceProvider = require("./surface-provider");

var _excluded = ["children", "as", "className", "display", "flexDirection", "alignItems", "justifyContent", "backgroundColor", "borderColor", "borderStyle", "borderWidth", "borderRadius", "padding", "paddingBlock", "paddingInline", "position", "height", "overflow", "width", "UNSAFE_style", "testId"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/**
 * __Box__
 *
 * Box is a primitive component that has the design decisions of the Atlassian Design System baked in.
 * Renders a `div` by default.
 *
 * @internal
 */
var Box = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, ref) {
  var children = _ref.children,
      _ref$as = _ref.as,
      Component = _ref$as === void 0 ? 'div' : _ref$as,
      className = _ref.className,
      _ref$display = _ref.display,
      display = _ref$display === void 0 ? 'flex' : _ref$display,
      flexDirection = _ref.flexDirection,
      alignItems = _ref.alignItems,
      justifyContent = _ref.justifyContent,
      backgroundColorTuple = _ref.backgroundColor,
      borderColorTuple = _ref.borderColor,
      borderStyle = _ref.borderStyle,
      borderWidth = _ref.borderWidth,
      borderRadius = _ref.borderRadius,
      padding = _ref.padding,
      paddingBlock = _ref.paddingBlock,
      paddingInline = _ref.paddingInline,
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? 'relative' : _ref$position,
      height = _ref.height,
      overflow = _ref.overflow,
      width = _ref.width,
      UNSAFE_style = _ref.UNSAFE_style,
      testId = _ref.testId,
      htmlAttributes = (0, _objectWithoutProperties2.default)(_ref, _excluded);

  var _ref2 = backgroundColorTuple || [],
      _ref3 = (0, _slicedToArray2.default)(_ref2, 2),
      backgroundColor = _ref3[0],
      backgroundColorFallback = _ref3[1];

  var _ref4 = borderColorTuple || [],
      _ref5 = (0, _slicedToArray2.default)(_ref4, 2),
      borderColor = _ref5[0],
      borderColorFallback = _ref5[1];

  var node = (0, _react2.jsx)(Component, (0, _extends2.default)({
    style: _objectSpread(_objectSpread(_objectSpread({}, UNSAFE_style), backgroundColorFallback && {
      '--ds-bg-fb': backgroundColorFallback
    }), borderColorFallback && {
      '--ds-bo-fb': borderColorFallback
    }) // @ts-ignore
    ,
    ref: ref // eslint-disable-next-line @repo/internal/react/no-unsafe-spread-props

  }, htmlAttributes, {
    className: className,
    css: [baseStyles, display && displayMap[display], padding && paddingMap[padding], position && positionMap[position], paddingBlock && paddingBlockMap[paddingBlock], paddingInline && paddingInlineMap[paddingInline], alignItems && flexAlignItemsMap[alignItems], justifyContent && flexJustifyContentMap[justifyContent], backgroundColor && backgroundColorMap[backgroundColor], borderColor && borderColorMap[borderColor], borderStyle && borderStyleMap[borderStyle], borderWidth && borderWidthMap[borderWidth], borderRadius && borderRadiusMap[borderRadius], flexDirection && flexDirectionMap[flexDirection], width && widthMap[width], height && heightMap[height]],
    "data-testid": testId
  }), children);
  return backgroundColor ? (0, _react2.jsx)(_surfaceProvider.SurfaceContext.Provider, {
    value: backgroundColor
  }, node) : node;
});
Box.displayName = 'Box';
var _default = Box; // <<< STYLES GO HERE >>>

exports.default = _default;
var borderStyleMap = {
  none: (0, _react2.css)({
    borderStyle: 'none'
  }),
  solid: (0, _react2.css)({
    borderStyle: 'solid'
  }),
  dashed: (0, _react2.css)({
    borderStyle: 'dashed'
  }),
  dotted: (0, _react2.css)({
    borderStyle: 'dotted'
  })
};
var borderWidthMap = {
  '0px': (0, _react2.css)({
    borderWidth: '0px'
  }),
  '1px': (0, _react2.css)({
    borderWidth: '1px'
  }),
  '2px': (0, _react2.css)({
    borderWidth: '2px'
  }),
  '3px': (0, _react2.css)({
    borderWidth: '3px'
  })
};
var borderRadiusMap = {
  normal: (0, _react2.css)({
    borderRadius: '3px'
  }),
  rounded: (0, _react2.css)({
    borderRadius: '50%'
  }),
  badge: (0, _react2.css)({
    borderRadius: '8px'
  })
};
var flexDirectionMap = {
  column: (0, _react2.css)({
    flexDirection: 'column'
  }),
  row: (0, _react2.css)({
    flexDirection: 'row'
  })
};
var flexAlignItemsMap = {
  center: (0, _react2.css)({
    alignItems: 'center'
  }),
  baseline: (0, _react2.css)({
    alignItems: 'baseline'
  }),
  flexStart: (0, _react2.css)({
    alignItems: 'flex-start'
  }),
  flexEnd: (0, _react2.css)({
    alignItems: 'flex-end'
  })
};
var flexJustifyContentMap = {
  center: (0, _react2.css)({
    justifyContent: 'center'
  }),
  flexStart: (0, _react2.css)({
    justifyContent: 'flex-start'
  }),
  flexEnd: (0, _react2.css)({
    justifyContent: 'flex-end'
  })
};
var displayMap = {
  block: (0, _react2.css)({
    display: 'block'
  }),
  inline: (0, _react2.css)({
    display: 'inline'
  }),
  flex: (0, _react2.css)({
    display: 'flex'
  }),
  inlineFlex: (0, _react2.css)({
    display: 'inline-flex'
  })
};
var baseStyles = (0, _react2.css)({
  boxSizing: 'border-box',
  appearance: 'none',
  border: 'none'
});
var overflowMap = {
  auto: (0, _react2.css)({
    overflow: 'auto'
  })
};
var positionMap = {
  absolute: (0, _react2.css)({
    position: 'absolute'
  }),
  relative: (0, _react2.css)({
    position: 'relative'
  }),
  static: (0, _react2.css)({
    position: 'static'
  })
};
/**
 * THIS SECTION WAS CREATED VIA CODEGEN DO NOT MODIFY {@see http://go/af-codegen}
 * @codegen <<SignedSource::57b4c7c177fdfae3f7cd4f00287fd30e>>
 * @codegenId spacing
 * @codegenCommand yarn codegen-styles
 * @codegenParams ["padding", "paddingBlock", "paddingInline", "width", "height"]
 */

var paddingMap = {
  'sp-0': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-0']
  }),
  'sp-25': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-25']
  }),
  'sp-50': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-50']
  }),
  'sp-75': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-75']
  }),
  'sp-100': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-100']
  }),
  'sp-150': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-150']
  }),
  'sp-200': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-200']
  }),
  'sp-300': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-300']
  }),
  'sp-400': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-400']
  }),
  'sp-500': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-500']
  }),
  'sp-600': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-600']
  }),
  'sp-800': (0, _react2.css)({
    padding: _constants.SPACING_SCALE['sp-800']
  })
};
var paddingBlockMap = {
  'sp-0': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-0']
  }),
  'sp-25': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-25']
  }),
  'sp-50': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-50']
  }),
  'sp-75': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-75']
  }),
  'sp-100': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-100']
  }),
  'sp-150': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-150']
  }),
  'sp-200': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-200']
  }),
  'sp-300': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-300']
  }),
  'sp-400': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-400']
  }),
  'sp-500': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-500']
  }),
  'sp-600': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-600']
  }),
  'sp-800': (0, _react2.css)({
    paddingBlock: _constants.SPACING_SCALE['sp-800']
  })
};
var paddingInlineMap = {
  'sp-0': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-0']
  }),
  'sp-25': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-25']
  }),
  'sp-50': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-50']
  }),
  'sp-75': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-75']
  }),
  'sp-100': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-100']
  }),
  'sp-150': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-150']
  }),
  'sp-200': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-200']
  }),
  'sp-300': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-300']
  }),
  'sp-400': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-400']
  }),
  'sp-500': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-500']
  }),
  'sp-600': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-600']
  }),
  'sp-800': (0, _react2.css)({
    paddingInline: _constants.SPACING_SCALE['sp-800']
  })
};
var widthMap = {
  'sp-0': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-0']
  }),
  'sp-25': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-25']
  }),
  'sp-50': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-50']
  }),
  'sp-75': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-75']
  }),
  'sp-100': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-100']
  }),
  'sp-150': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-150']
  }),
  'sp-200': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-200']
  }),
  'sp-300': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-300']
  }),
  'sp-400': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-400']
  }),
  'sp-500': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-500']
  }),
  'sp-600': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-600']
  }),
  'sp-800': (0, _react2.css)({
    width: _constants.SPACING_SCALE['sp-800']
  })
};
var heightMap = {
  'sp-0': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-0']
  }),
  'sp-25': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-25']
  }),
  'sp-50': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-50']
  }),
  'sp-75': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-75']
  }),
  'sp-100': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-100']
  }),
  'sp-150': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-150']
  }),
  'sp-200': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-200']
  }),
  'sp-300': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-300']
  }),
  'sp-400': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-400']
  }),
  'sp-500': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-500']
  }),
  'sp-600': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-600']
  }),
  'sp-800': (0, _react2.css)({
    height: _constants.SPACING_SCALE['sp-800']
  })
};
/**
 * @codegenEnd
 */

/**
 * THIS SECTION WAS CREATED VIA CODEGEN DO NOT MODIFY {@see http://go/af-codegen}
 * @codegen <<SignedSource::ebb55786a54803214357d0eef0cac448>>
 * @codegenId colors
 * @codegenCommand yarn codegen-styles
 * @codegenParams ["border", "background"]
 */

var borderColorMap = {
  'color.border': (0, _react2.css)({
    borderColor: "var(--ds-border, var(--ds-bo-fb))"
  }),
  bold: (0, _react2.css)({
    borderColor: "var(--ds-border-bold, var(--ds-bo-fb))"
  }),
  inverse: (0, _react2.css)({
    borderColor: "var(--ds-border-inverse, var(--ds-bo-fb))"
  }),
  focused: (0, _react2.css)({
    borderColor: "var(--ds-border-focused, var(--ds-bo-fb))"
  }),
  input: (0, _react2.css)({
    borderColor: "var(--ds-border-input, var(--ds-bo-fb))"
  }),
  disabled: (0, _react2.css)({
    borderColor: "var(--ds-border-disabled, var(--ds-bo-fb))"
  }),
  brand: (0, _react2.css)({
    borderColor: "var(--ds-border-brand, var(--ds-bo-fb))"
  }),
  selected: (0, _react2.css)({
    borderColor: "var(--ds-border-selected, var(--ds-bo-fb))"
  }),
  danger: (0, _react2.css)({
    borderColor: "var(--ds-border-danger, var(--ds-bo-fb))"
  }),
  warning: (0, _react2.css)({
    borderColor: "var(--ds-border-warning, var(--ds-bo-fb))"
  }),
  success: (0, _react2.css)({
    borderColor: "var(--ds-border-success, var(--ds-bo-fb))"
  }),
  discovery: (0, _react2.css)({
    borderColor: "var(--ds-border-discovery, var(--ds-bo-fb))"
  }),
  information: (0, _react2.css)({
    borderColor: "var(--ds-border-information, var(--ds-bo-fb))"
  })
};
var backgroundColorMap = {
  disabled: (0, _react2.css)({
    backgroundColor: "var(--ds-background-disabled, var(--ds-bg-fb))"
  }),
  'inverse.subtle': (0, _react2.css)({
    backgroundColor: "var(--ds-background-inverse-subtle, var(--ds-bg-fb))"
  }),
  input: (0, _react2.css)({
    backgroundColor: "var(--ds-background-input, var(--ds-bg-fb))"
  }),
  neutral: (0, _react2.css)({
    backgroundColor: "var(--ds-background-neutral, var(--ds-bg-fb))"
  }),
  'neutral.subtle': (0, _react2.css)({
    backgroundColor: "var(--ds-background-neutral-subtle, var(--ds-bg-fb))"
  }),
  'neutral.bold': (0, _react2.css)({
    backgroundColor: "var(--ds-background-neutral-bold, var(--ds-bg-fb))"
  }),
  'brand.bold': (0, _react2.css)({
    backgroundColor: "var(--ds-background-brand-bold, var(--ds-bg-fb))"
  }),
  selected: (0, _react2.css)({
    backgroundColor: "var(--ds-background-selected, var(--ds-bg-fb))"
  }),
  'selected.bold': (0, _react2.css)({
    backgroundColor: "var(--ds-background-selected-bold, var(--ds-bg-fb))"
  }),
  danger: (0, _react2.css)({
    backgroundColor: "var(--ds-background-danger, var(--ds-bg-fb))"
  }),
  'danger.bold': (0, _react2.css)({
    backgroundColor: "var(--ds-background-danger-bold, var(--ds-bg-fb))"
  }),
  warning: (0, _react2.css)({
    backgroundColor: "var(--ds-background-warning, var(--ds-bg-fb))"
  }),
  'warning.bold': (0, _react2.css)({
    backgroundColor: "var(--ds-background-warning-bold, var(--ds-bg-fb))"
  }),
  success: (0, _react2.css)({
    backgroundColor: "var(--ds-background-success, var(--ds-bg-fb))"
  }),
  'success.bold': (0, _react2.css)({
    backgroundColor: "var(--ds-background-success-bold, var(--ds-bg-fb))"
  }),
  discovery: (0, _react2.css)({
    backgroundColor: "var(--ds-background-discovery, var(--ds-bg-fb))"
  }),
  'discovery.bold': (0, _react2.css)({
    backgroundColor: "var(--ds-background-discovery-bold, var(--ds-bg-fb))"
  }),
  information: (0, _react2.css)({
    backgroundColor: "var(--ds-background-information, var(--ds-bg-fb))"
  }),
  'information.bold': (0, _react2.css)({
    backgroundColor: "var(--ds-background-information-bold, var(--ds-bg-fb))"
  }),
  'color.blanket': (0, _react2.css)({
    backgroundColor: "var(--ds-blanket, var(--ds-bg-fb))"
  }),
  'color.blanket.selected': (0, _react2.css)({
    backgroundColor: "var(--ds-blanket-selected, var(--ds-bg-fb))"
  }),
  'color.blanket.danger': (0, _react2.css)({
    backgroundColor: "var(--ds-blanket-danger, var(--ds-bg-fb))"
  }),
  'elevation.surface': (0, _react2.css)({
    backgroundColor: "var(--ds-surface, var(--ds-bg-fb))"
  }),
  'elevation.surface.sunken': (0, _react2.css)({
    backgroundColor: "var(--ds-surface-sunken, var(--ds-bg-fb))"
  }),
  'elevation.surface.raised': (0, _react2.css)({
    backgroundColor: "var(--ds-surface-raised, var(--ds-bg-fb))"
  }),
  'elevation.surface.overlay': (0, _react2.css)({
    backgroundColor: "var(--ds-surface-overlay, var(--ds-bg-fb))"
  })
};
/**
 * @codegenEnd
 */