"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = require("react");

var _react2 = require("@emotion/react");

var _constants = require("../constants");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var flexAlignItemsMap = {
  center: (0, _react2.css)({
    alignItems: 'center'
  }),
  baseline: (0, _react2.css)({
    alignItems: 'baseline'
  }),
  flexStart: (0, _react2.css)({
    alignItems: 'flex-start'
  }),
  flexEnd: (0, _react2.css)({
    alignItems: 'flex-end'
  }),
  start: (0, _react2.css)({
    alignItems: 'start'
  }),
  end: (0, _react2.css)({
    alignItems: 'end'
  })
};
var flexJustifyContentMap = {
  center: (0, _react2.css)({
    justifyContent: 'center'
  }),
  flexStart: (0, _react2.css)({
    justifyContent: 'flex-start'
  }),
  flexEnd: (0, _react2.css)({
    justifyContent: 'flex-end'
  }),
  start: (0, _react2.css)({
    justifyContent: 'start'
  }),
  end: (0, _react2.css)({
    justifyContent: 'end'
  })
};
var flexWrapMap = {
  wrap: (0, _react2.css)({
    flexWrap: 'wrap'
  })
};
var baseStyles = (0, _react2.css)({
  display: 'flex',
  boxSizing: 'border-box',
  flexDirection: 'column'
});
/**
 * __Stack__
 *
 * Stack is a primitive component based on flexbox that manages the vertical layout of direct children.
 * Renders a `div` by default.
 *
 */

var Stack = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, ref) {
  var gap = _ref.gap,
      alignItems = _ref.alignItems,
      justifyContent = _ref.justifyContent,
      flexWrap = _ref.flexWrap,
      children = _ref.children,
      UNSAFE_style = _ref.UNSAFE_style,
      testId = _ref.testId;
  return (0, _react2.jsx)("div", {
    style: _objectSpread({}, UNSAFE_style),
    css: [baseStyles, gap && rowGapMap[gap], alignItems && flexAlignItemsMap[alignItems], justifyContent && flexJustifyContentMap[justifyContent], flexWrap && flexWrapMap[flexWrap]],
    "data-testid": testId,
    ref: ref
  }, children);
});
Stack.displayName = 'Stack';
var _default = Stack;
/**
 * THIS SECTION WAS CREATED VIA CODEGEN DO NOT MODIFY {@see http://go/af-codegen}
 * @codegen <<SignedSource::13c9344cdb18845e176c0ca78b2972d3>>
 * @codegenId spacing
 * @codegenCommand yarn codegen-styles
 * @codegenParams ["rowGap"]
 */

exports.default = _default;
var rowGapMap = {
  'sp-0': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-0']
  }),
  'sp-25': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-25']
  }),
  'sp-50': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-50']
  }),
  'sp-75': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-75']
  }),
  'sp-100': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-100']
  }),
  'sp-150': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-150']
  }),
  'sp-200': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-200']
  }),
  'sp-300': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-300']
  }),
  'sp-400': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-400']
  }),
  'sp-500': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-500']
  }),
  'sp-600': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-600']
  }),
  'sp-800': (0, _react2.css)({
    rowGap: _constants.SPACING_SCALE['sp-800']
  })
};
/**
 * @codegenEnd
 */