"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("@emotion/react");

var _tinyInvariant = _interopRequireDefault(require("tiny-invariant"));

var _colorMap = require("../internal/color-map");

var _surfaceProvider = require("./surface-provider");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var asAllowlist = ['span', 'div', 'p'];
var fontFamily = "-apple-system, BlinkMacSystemFont, 'Segoe UI', 'Roboto', 'Oxygen', 'Ubuntu', 'Fira Sans', 'Droid Sans', 'Helvetica Neue', sans-serif";
var fontSizeMap = {
  '11px': (0, _react.css)({
    fontSize: '11px'
  }),
  '12px': (0, _react.css)({
    fontSize: '12px'
  }),
  '14px': (0, _react.css)({
    fontSize: '14px'
  })
};
// NOTE: can't use numbers as keys or Constellation won't build. Weird one.
var fontWeightMap = {
  '400': (0, _react.css)({
    fontWeight: 400
  }),
  '500': (0, _react.css)({
    fontWeight: 500
  }),
  '700': (0, _react.css)({
    fontWeight: 700
  })
};
var lineHeightMap = {
  '12px': (0, _react.css)({
    lineHeight: '12px'
  }),
  '16px': (0, _react.css)({
    lineHeight: '16px'
  }),
  '20px': (0, _react.css)({
    lineHeight: '20px'
  }),
  '24px': (0, _react.css)({
    lineHeight: '24px'
  }),
  '28px': (0, _react.css)({
    lineHeight: '28px'
  }),
  '32px': (0, _react.css)({
    lineHeight: '32px'
  }),
  '40px': (0, _react.css)({
    lineHeight: '40px'
  })
};
var textAlignMap = {
  center: (0, _react.css)({
    textAlign: 'center'
  }),
  end: (0, _react.css)({
    textAlign: 'end'
  }),
  start: (0, _react.css)({
    textAlign: 'start'
  })
};
var textTransformMap = {
  none: (0, _react.css)({
    textTransform: 'none'
  }),
  lowercase: (0, _react.css)({
    textTransform: 'lowercase'
  }),
  uppercase: (0, _react.css)({
    textTransform: 'uppercase'
  })
};
var verticalAlignMap = {
  top: (0, _react.css)({
    verticalAlign: 'top'
  }),
  middle: (0, _react.css)({
    verticalAlign: 'middle'
  }),
  bottom: (0, _react.css)({
    verticalAlign: 'bottom'
  })
};
var baseStyles = (0, _react.css)({
  boxSizing: 'border-box',
  margin: '0px',
  padding: '0px',
  fontFamily: fontFamily
});
var truncateStyles = (0, _react.css)({
  overflow: 'hidden',
  textOverflow: 'ellipsis',
  whiteSpace: 'nowrap'
});
/**
 * __Text__
 *
 * Text is a primitive component that has the Atlassian Design System's design guidelines baked in.
 * This includes considerations for text attributes such as color, font size, font weight, and line height.
 * It renders a `span` by default.
 *
 * @internal
 */

var Text = function Text(_ref) {
  var _ref$as = _ref.as,
      Component = _ref$as === void 0 ? 'span' : _ref$as,
      children = _ref.children,
      colorTuple = _ref.color,
      fontSize = _ref.fontSize,
      fontWeight = _ref.fontWeight,
      lineHeight = _ref.lineHeight,
      _ref$shouldTruncate = _ref.shouldTruncate,
      shouldTruncate = _ref$shouldTruncate === void 0 ? false : _ref$shouldTruncate,
      textAlign = _ref.textAlign,
      textTransform = _ref.textTransform,
      verticalAlign = _ref.verticalAlign,
      testId = _ref.testId,
      UNSAFE_style = _ref.UNSAFE_style;
  var surface = (0, _surfaceProvider.useSurface)(); // @ts-ignore

  var _ref2 = colorTuple || [],
      _ref3 = (0, _slicedToArray2.default)(_ref2, 2),
      _ref3$ = _ref3[0],
      color = _ref3$ === void 0 ? _colorMap.colorMap[surface] : _ref3$,
      fallback = _ref3[1];

  (0, _tinyInvariant.default)(asAllowlist.includes(Component), "@atlaskit/ds-explorations: Text received an invalid \"as\" value of \"".concat(Component, "\""));
  return (0, _react.jsx)(Component, {
    style: _objectSpread(_objectSpread({}, UNSAFE_style), fallback && {
      '--ds-co-fb': fallback
    }),
    css: [baseStyles, color && textColorMap[color], fontSize && fontSizeMap[fontSize], fontWeight && fontWeightMap[fontWeight], lineHeight && lineHeightMap[lineHeight], shouldTruncate && truncateStyles, textAlign && textAlignMap[textAlign], textTransform && textTransformMap[textTransform], verticalAlign && verticalAlignMap[verticalAlign]],
    "data-testid": testId
  }, children);
};

var _default = Text;
/**
 * THIS SECTION WAS CREATED VIA CODEGEN DO NOT MODIFY {@see http://go/af-codegen}
 * @codegen <<SignedSource::140ffff6e1310c1c37e2067e2c232b92>>
 * @codegenId colors
 * @codegenCommand yarn codegen-styles
 * @codegenParams ["text"]
 */

exports.default = _default;
var textColorMap = {
  'color.text': (0, _react.css)({
    color: "var(--ds-text, var(--ds-co-fb))"
  }),
  subtle: (0, _react.css)({
    color: "var(--ds-text-subtle, var(--ds-co-fb))"
  }),
  subtlest: (0, _react.css)({
    color: "var(--ds-text-subtlest, var(--ds-co-fb))"
  }),
  disabled: (0, _react.css)({
    color: "var(--ds-text-disabled, var(--ds-co-fb))"
  }),
  inverse: (0, _react.css)({
    color: "var(--ds-text-inverse, var(--ds-co-fb))"
  }),
  brand: (0, _react.css)({
    color: "var(--ds-text-brand, var(--ds-co-fb))"
  }),
  selected: (0, _react.css)({
    color: "var(--ds-text-selected, var(--ds-co-fb))"
  }),
  danger: (0, _react.css)({
    color: "var(--ds-text-danger, var(--ds-co-fb))"
  }),
  warning: (0, _react.css)({
    color: "var(--ds-text-warning, var(--ds-co-fb))"
  }),
  'warning.inverse': (0, _react.css)({
    color: "var(--ds-text-warning-inverse, var(--ds-co-fb))"
  }),
  success: (0, _react.css)({
    color: "var(--ds-text-success, var(--ds-co-fb))"
  }),
  discovery: (0, _react.css)({
    color: "var(--ds-text-discovery, var(--ds-co-fb))"
  }),
  information: (0, _react.css)({
    color: "var(--ds-text-information, var(--ds-co-fb))"
  })
};
/**
 * @codegenEnd
 */