import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/** @jsx jsx */
import { Children, forwardRef, Fragment } from 'react';
import { css, jsx } from '@emotion/react';
import { SPACING_SCALE } from '../constants';
import Text from './text.partial';
var flexAlignItemsMap = {
  center: css({
    alignItems: 'center'
  }),
  baseline: css({
    alignItems: 'baseline'
  }),
  flexStart: css({
    alignItems: 'flex-start'
  }),
  flexEnd: css({
    alignItems: 'flex-end'
  }),
  start: css({
    alignItems: 'start'
  }),
  end: css({
    alignItems: 'end'
  })
};
var flexJustifyContentMap = {
  center: css({
    justifyContent: 'center'
  }),
  flexStart: css({
    justifyContent: 'flex-start'
  }),
  flexEnd: css({
    justifyContent: 'flex-end'
  }),
  start: css({
    justifyContent: 'start'
  }),
  end: css({
    justifyContent: 'end'
  })
};
var flexWrapMap = {
  wrap: css({
    flexWrap: 'wrap'
  })
};
var baseStyles = css({
  display: 'flex',
  boxSizing: 'border-box',
  flexDirection: 'row'
});
/**
 * __Inline__
 *
 * Inline is a primitive component based on flexbox that manages the horizontal layout of direct children.
 * Renders a `div` by default.
 *
 */

var Inline = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var gap = _ref.gap,
      alignItems = _ref.alignItems,
      justifyContent = _ref.justifyContent,
      flexWrap = _ref.flexWrap,
      divider = _ref.divider,
      UNSAFE_style = _ref.UNSAFE_style,
      children = _ref.children,
      testId = _ref.testId;
  var dividerComponent = typeof divider === 'string' ? jsx(Text, null, divider) : divider;
  return jsx("div", {
    style: _objectSpread({}, UNSAFE_style),
    css: [baseStyles, gap && columnGapMap[gap], alignItems && flexAlignItemsMap[alignItems], justifyContent && flexJustifyContentMap[justifyContent], flexWrap && flexWrapMap[flexWrap]],
    "data-testid": testId,
    ref: ref
  }, Children.map(children, function (child, index) {
    return jsx(Fragment, null, divider && index > 0 ? dividerComponent : null, child);
  }));
});
Inline.displayName = 'Inline';
export default Inline;
/**
 * THIS SECTION WAS CREATED VIA CODEGEN DO NOT MODIFY {@see http://go/af-codegen}
 * @codegen <<SignedSource::7a985afa5e15ffd4f6f9c0db0e99ceb6>>
 * @codegenId spacing
 * @codegenCommand yarn codegen-styles
 * @codegenParams ["columnGap"]
 */

var columnGapMap = {
  'sp-0': css({
    columnGap: SPACING_SCALE['sp-0']
  }),
  'sp-25': css({
    columnGap: SPACING_SCALE['sp-25']
  }),
  'sp-50': css({
    columnGap: SPACING_SCALE['sp-50']
  }),
  'sp-75': css({
    columnGap: SPACING_SCALE['sp-75']
  }),
  'sp-100': css({
    columnGap: SPACING_SCALE['sp-100']
  }),
  'sp-150': css({
    columnGap: SPACING_SCALE['sp-150']
  }),
  'sp-200': css({
    columnGap: SPACING_SCALE['sp-200']
  }),
  'sp-300': css({
    columnGap: SPACING_SCALE['sp-300']
  }),
  'sp-400': css({
    columnGap: SPACING_SCALE['sp-400']
  }),
  'sp-500': css({
    columnGap: SPACING_SCALE['sp-500']
  }),
  'sp-600': css({
    columnGap: SPACING_SCALE['sp-600']
  }),
  'sp-800': css({
    columnGap: SPACING_SCALE['sp-800']
  })
};
/**
 * @codegenEnd
 */